package org.antlr.misc;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.antlr.misc.OrderedHashSet;

public class Graph<T> {
  protected Map<T, Node<T>> nodes = new HashMap<T, Node<T>>();
  
  public void addEdge(T a, T b) {
    Node<T> a_node = getNode(a);
    Node<T> b_node = getNode(b);
    a_node.addEdge(b_node);
  }
  
  protected Node<T> getNode(T a) {
    Node<T> existing = this.nodes.get(a);
    if (existing != null)
      return existing; 
    Node<T> n = new Node(a);
    this.nodes.put(a, n);
    return n;
  }
  
  public List<T> sort() {
    OrderedHashSet orderedHashSet = new OrderedHashSet();
    ArrayList<T> sorted = new ArrayList<T>();
    while (orderedHashSet.size() < this.nodes.size()) {
      Node<T> n = null;
      for (Node<T> tNode : this.nodes.values()) {
        n = tNode;
        if (!orderedHashSet.contains(n))
          break; 
      } 
      DFS(n, (Set<Node<T>>)orderedHashSet, sorted);
    } 
    return sorted;
  }
  
  public void DFS(Node<T> n, Set<Node<T>> visited, ArrayList<T> sorted) {
    if (visited.contains(n))
      return; 
    visited.add(n);
    if (n.edges != null)
      for (Node<T> target : (Iterable<Node<T>>)n.edges)
        DFS(target, visited, sorted);  
    sorted.add((T)n.payload);
  }
}
